unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPServer;

const
  STREAM_PREFIX=-2;

type
  TForm1 = class(TForm)
    IdTCPServer1: TIdTCPServer;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure IdTCPServer1Disconnect(AThread: TIdPeerThread);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
  private
    { Private declarations }
    curAThread: TIdPeerThread;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  IdTCPServer1.Active:=true;
  Memo1.Lines.Add('Server Start.')
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IdTCPServer1.Active:=false;
  Memo1.Lines.Add('Server stop.')
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IdTCPServer1.Active:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  aFileName: string;
  uFileName: utf8string;
  ss: TStringStream;
  fs: TMemoryStream;
begin
  if not FileExists(Edit1.Text) then
    exit;
  if not curAThread.Terminated and curAThread.Connection.Connected then
  begin
    aFileName:= ExtractFileName(Edit1.Text) ;
    ufileName:= AnsiToUtf8(aFileName);
    ss:= TStringStream.Create(ufileName);
    curAThread.Connection.SendBufferSize:= 8192;
    curAThread.Connection.WriteStream(ss, True, True);
    curAThread.Connection.WriteInteger(STREAM_PREFIX);
    fs := TMemoryStream.Create;
    fs.LoadFromFile(Edit1.Text);
    try
      curAThread.Connection.WriteStream(fs, True, True);
    finally
      fs.Free;
    end;
    Memo1.Lines.Add(aFileName+' send completed.');
  end;
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
var
  ip: string;
begin
  curAThread:= AThread;
  ip:= AThread.Connection.Socket.Binding.PeerIP;
  Memo1.Lines.Add(ip+' Connet.');
end;

procedure TForm1.IdTCPServer1Disconnect(AThread: TIdPeerThread);
begin
  Memo1.Lines.Add('Disconnect.');
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
begin
  curAThread:= AThread;
end;

end.
